unit NoTitleBar1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
   LResources, Spin, Arrow, math, BGRAbitmap, BGRAbitmapTypes, BGRAIconCursor;

type

	 { TForm1 }

   TForm1 = class(TForm)
			Arrow1: TArrow;
			Arrow2: TArrow;
			Button1: TButton;
			Image1: TImage;
			Image2: TImage;
			Image3: TImage;
			Panel1: TPanel;
			Icons: TRadioGroup;
			SpinEdit1: TSpinEdit;
			SpinEdit2: TSpinEdit;
      procedure Button1Click(Sender: TObject);
			procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
			procedure FormCreate(Sender: TObject);

			procedure IconsSelectionChanged(Sender: TObject);
			procedure Image3MouseDown(Sender: TObject; Button: TMouseButton;
				 Shift: TShiftState; X, Y: Integer);
      procedure showTBarIcons;
      procedure SelectIconSet (i: Integer);
			procedure FormPaint(Sender: TObject);
			procedure Panel1Click(Sender: TObject);
			procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
				 Shift: TShiftState; X, Y: Integer);
			procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
				 Y: Integer);
			procedure Panel1Paint(Sender: TObject);
			procedure SpinEdit1Change(Sender: TObject);
			procedure SpinEdit2Change(Sender: TObject);
   private
   const delta = 30;
   var xoff, yoff : Integer; // move Form
       xMaximize, xClose : Integer;
       fx, fy : Integer; // resize Form
       doResize : boolean;
   public

   end;

var
   Form1: TForm1;

implementation

{$R *.lfm}

const
Inames : array[0..5] of string = (
            'KDE', 'KDE_1', 'KDE_old',
            'win7', 'win95', 'win_A');


function YES (MSG : String) : Boolean;
begin
 result := MessageDlg(MSG, mtConfirmation, [mbYes, mbNo], 0) = mrYes;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
   close;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
   if yes ('Close Application?') then CloseAction:= caFree else
                                       CloseAction:= caNone;
end;


procedure TForm1.SelectIconSet (i: Integer);
var col : TColor;
    img: TBGRAbitmap;
begin
ensureRange(i,0,high(Inames));
img := TBGRAbitmap.Create; //
Img.LoadFromResource(Inames[i]);
Image3.width := img.Width;
Image3.height := img.Height;
Image3.Top := (Panel1.Height - img.Height) div 2;
if Image3.Top <= 0 then Image3.Top := 1;
Image3.Left := Panel1.width - img.width - 5;
Image3.Picture.Bitmap.SetSize(Image3.width,Image3.height);
Application.ProcessMessages;
Img.Draw (Image3.Canvas,0,0);
Panel1.Color := img.GetPixel(0,0);
col:= img.GetPixel(0,0);
if col.red+col.green+col.blue < 200 then Panel1.Canvas.Font.Color := clWhite else
                                     Panel1.Canvas.Font.Color := clBlack;
img.free;
if i <> 5 then
	 begin
		  xMaximize := Image3.Width div 3;
		  xclose := xMaximize * 2+1;
	 end else
	 begin
		  xMaximize :=37;
		  xClose :=  69;
	 end;
end;

procedure TForm1.showTBarIcons;
var i,x,y : integer;
    R, RDest: TRect;
    img: TBGRAbitmap;
begin
Image2.Canvas.Brush.color := clWhite;
Image2.Canvas.FillRect (0,0,Image2.width, Image2.Height);
y := 5; x := 5;
//showMessage ('Load Resources');
for i := 0 to 5 do
   begin
   //showMessage ('I= '+IntToStr(i));
   img := TBGRAbitmap.Create; //
   Img.LoadFromResource(Inames[i]);
   R:= Rect(0,0,img.Width, img.Height);
   RDest := Rect (x,y,x+img.Width,y+ img.height);
   Image2.Canvas.CopyRect(RDest,img.canvas,R);
   img.free;
   inc(y,35);
   end; // i
end;

procedure TForm1.FormCreate(Sender: TObject);
var
    x,xy, xyDest,i : Integer;
    R : Trect;
    ICur : TBGRAIconCursor;
    MemStream: TMemoryStream;
    bmp : TBGRABitmap;
begin
  // Icon
  ICur := TBGRAIconCursor.Create;
  MemStream:= TMemoryStream.Create;
  Application.Icon.SaveToStream(MemStream);
  MemStream.Position:=0;
  ICur.LoadFromStream(MemStream);
  bmp := TBGRABitmap.Create;
  BGRAreplace (bmp, ICur.GetBitmap(0));
  xy := Image1.Height;
  BGRAreplace (bmp,bmp.resample(xy,xy));
  bmp.draw(Image1.Canvas,0,0,false);
  bmp.free;
  ICur.Free;
  MemStream.free;



  (*
  xy := application.Icon.Height;
  tmp := TBGRAbitmap.Create (xy,xy);
  R := Rect(0,0,xy,xy);
  tmp.Canvas.CopyRect (R,application.Icon.Canvas,R);
  xyDest := Image1.Height;
  BGRAreplace (tmp,tmp.resample(xyDest,xyDest));
  tmp.Draw(Image1.canvas,0,0);
  tmp.free;
  *)
  showTBarIcons;
  for i := 0 to high(Inames) do
    Icons.Items.add (Inames[i]);
  Icons.ItemIndex := 0;
  SelectIconSet (0);
  // X
  SpinEdit1.MinValue:= 200;
  SpinEdit1.MaxValue:= Screen.Width;
  SpinEdit1.Value := self.width;
  // Y
  SpinEdit2.MinValue:= 200;
  SpinEdit2.MaxValue:= Screen.Height;
  SpinEdit2.Value := self.height;
end;

const BorderDelta = 10;


procedure TForm1.IconsSelectionChanged(Sender: TObject);
begin
   SelectIconSet (Icons.ItemIndex);
end;

procedure TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
	 Shift: TShiftState; X, Y: Integer);
begin
       if x >= xClose  then close else
           begin
           if x >= xMaximize then
              begin
              if WindowState= wsMaximized then WindowState := wsNormal else
                  WindowState:= wsMaximized;
							end else WindowState:= wsMinimized;
					 end;
  // showMessage ('Icon '+IntToStr(x));
end;

procedure TForm1.FormPaint(Sender: TObject);
var R : TRect;
begin
Canvas.Pen.Color := clRed;
R := Rect(1,1,width-1,Height-1);
Canvas.Rectangle (R);

end;

procedure TForm1.Panel1Click(Sender: TObject);
begin


end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
	 Shift: TShiftState; X, Y: Integer);
begin

			   if ssLeft in Shift then begin xoff := x; yOff := y; end;
end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
	 Y: Integer);
begin
   if ssLeft in Shift then
      begin
      left := Left+x -Xoff;
      top := top +y - yoff;
			end;
end;

procedure TForm1.Panel1Paint(Sender: TObject);

var x,i : integer;
begin
   Panel1.Canvas.Pen.Color := clBlack;
   (*
   for i := 1 to 3 do
      begin
      x := Panel1.Width -i*delta;
      Panel1.Canvas.Line(x,0,x,Panel1.Height);
   	end;
    *)
  // caption
   x := (Panel1.Width - Panel1.Canvas.TextWidth(Caption) ) div 2;
   Panel1.Canvas.TextOut (x,5,caption);

   Panel1.Canvas.Pen.Color := clRed;
	 Panel1.Canvas.Line(0,0,Panel1.Width,0);
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
   width := SpinEdit1.Value;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
   height := SpinEdit2.Value;
end;

Initialization
{$I TBarIcons.lrs}
end.

